'use strict'

/**
 *
 *
 * @author EllisRan.
 * @date 2018/6/22
 * @version
 */
import db from '../../database'
const path = require('path')
const electron = require('electron')
const ipcMain = electron.ipcMain
const folderpath = 'data/software'
const download = require('electron-dl').download
// const BrowserWindow = electron.BrowserWindow
const app = electron.app
const fs = require('fs')
const fse = require('fs-extra')
const compressing = require('compressing')
const mkdirp = require('mkdirp')
const __appPath = app.getPath('userData')

const downloads = function (win) {
  let item
  ipcMain.on('cancel', (eve, id) => {
    // cancelStatus = true
    item.cancel()
  })
  ipcMain.on('pause', (eve, id) => {
    // pauseStatus = true
    item.pause()
  })
  ipcMain.on('resume', (eve, id) => {
    // resumeStatus = true
    // item = db.get('sc_download.item').value()
    // console.log(db.read().get('sc_download.item').value())
    if (!item) {
      // item = db.read().get('sc_download.item').value()
      console.log(item.canResume())
      console.log(item)
    }
    item.resume()
  })

  ipcMain.on('download', (event, args) => {
    let info = db.read().get('sc_download').getById(args.id).value()
    let downloadpath = info.down_url
    let options = {
      saveAs: false,
      directory: path.join(__appPath, folderpath),
      filename: info.savepath,
      errorTitle: '下载失败',
      onStarted: function (items) {
        item = items // 必须抽离出来控制item，否则二次使用时会报错
      },
      onProgress: function (status) {
        win.webContents.send('downloadtips', {percent: Math.ceil(status * 100), id: args.id, index: args.index})
      },
      onCancel: function () {
        console.log('cancel download')
        try {
          // info.start = true
          // info.pause = false
          // info.resume = false
          // db.read().get('sc_download').getById(args.id).assign(info).write()
          let delpath = path.join(__appPath, folderpath, info.savepath)
          if (fs.existsSync(delpath)) {
            fse.removeSync(delpath)
          }
        } catch (err) {
          console.log(err)
        }
      }
    }
    download(win, downloadpath, options)
      .then(function (dl) {
        try {
          // 判断下载的是安装包 or 压缩包
          let zippath = path.join(__appPath, folderpath)
          let zipname = info.savepath
          let suffix = zipname.substring(zipname.lastIndexOf('.') + 1, zipname.length)
          if (suffix === 'exe') {
            console.log('ok')
            win.webContents.send('downloadsuccess', {id: args.id, savepath: path.join(zippath, zipname), index: args.index})
          } else {
            let exename = ''
            fs.createReadStream(path.join(zippath, zipname))
              .on('error', function (error) {
                throw error
              })
              .pipe(new compressing.zip.UncompressStream())
              .on('error', function (error) {
                throw error
              })
              .on('finish', function () {
                // 完成后删除zip压缩包
                fs.unlinkSync(path.join(zippath, zipname))
                console.log('ok')
                win.webContents.send('downloadsuccess', {id: args.id, savepath: path.join(zippath, exename), index: args.index})
              })
              .on('entry', function (header, stream, next) {
                stream.on('end', next)
                // header.type => file | directory
                // header.name => path name
                exename = header.name
                if (header.type === 'file') {
                  stream.pipe(fs.createWriteStream(path.join(zippath, header.name)))
                } else { // directory
                  mkdirp(path.join(zippath, header.name), err => {
                    if (err) throw err
                    stream.resume()
                  })
                }
              })
          }
        } catch (err) {
          console.log(err)
        }
      })
      .catch(console.error)
  })
}

export default downloads

// exports.initialize = function (win) {
//   ipcMain.on('download', (event, args) => {
//     let downloadpath = args
//     win.webContents.downloadURL(downloadpath)
//     let $event = event
//     win.webContents.session.on('will-download', (event, item, webContents) => {
//       const totalBytes = item.getTotalBytes()
//       const filename = item.getFilename()
//       item.setSavePath(path.join(folderpath, `${item.getFilename()}`))
//       item.on('updated', (event, state) => {
//         if (state === 'interrupted') {
//           $event.sender.send('downloadtips', 'Download is interrupted but can be resumed')
//         } else if (state === 'progressing') {
//           if (item.isPaused()) {
//             $event.sender.send('downloadtips', filename + ' 下载暂停')
//           } else {
//             console.log(item)
//             $event.sender.send('downloadtips', Math.ceil(item.getReceivedBytes() / totalBytes * 100))
//           }
//         }
//       })
//       item.once('done', (event, state) => {
//         if (state === 'completed') {
//           $event.sender.send('downloadtips', filename + ' 下载完成 共：' + conver(totalBytes))
//           $event.sender.send('notification-test', filename + ' 下载完成')
//         } else {
//           $event.sender.send('downloadtips', filename + ` 下载失败: ${state}`)
//           $event.sender.send('notification-test', filename + ` 下载失败: ${state}`)
//         }
//       })
//     })
//   })
// }
//
// /**
//  *
//  * @param 计算内存大小
//  * @return {string}
//  */
// function conver (limit) {
//   var size = ''
//   if (limit < 0.1 * 1024) { // 如果小于0.1KB转化成B
//     size = limit.toFixed(2) + 'B'
//   } else if (limit < 0.1 * 1024 * 1024) { // 如果小于0.1MB转化成KB
//     size = (limit / 1024).toFixed(2) + 'KB'
//   } else if (limit < 0.1 * 1024 * 1024 * 1024) { // 如果小于0.1GB转化成MB
//     size = (limit / (1024 * 1024)).toFixed(2) + 'MB'
//   } else { // 其他转化成GB
//     size = (limit / (1024 * 1024 * 1024)).toFixed(2) + 'GB'
//   }
//
//   var sizestr = size + ''
//   var len = sizestr.indexOf('.')
//   var dec = sizestr.substr(len + 1, 2)
//   if (dec === '00') { // 当小数点后为00时 去掉小数部分
//     return sizestr.substring(0, len) + sizestr.substr(len + 3, 2)
//   }
//   return sizestr
// }
