'use strict'

/**
 * 软件锁检测
 *
 * @author EllisRan.
 * @date 2018/6/20
 * @version
 */
import db from '../../database'
const path = require('path')
const ffi = require('ffi')
const electron = require('electron')
const Notification = electron.Notification
const ipcMain = electron.ipcMain
const usb = require('usb')
let usbFlag = false
const usbffi = function (win) {
  ipcMain.on('testUsb', function () {
    testUsb(win.webContents)
  })
  usb.on('attach', function (device) {
    testUsb(win.webContents, true)
  })
  usb.on('detach', async function (device) {
    if (usbFlag) {
      try {
        let pathstr = path.join('data/zhlData.dll')
        let libm = ffi.Library(pathstr, {
          'GetProductIDList': ['string', []]
        })
        // console.log(await libm.GetProductIDList())
        let alllist = await libm.GetProductIDList()
        if (alllist === '') {
          usbFlag = false
          win.webContents.send('usbOut')
          const notification = new Notification({
            title: '软件锁',
            body: '你的软件锁已拔出'
          })
          notification.show()
        }
      } catch (err) {
        console.error(err)
      }
    }
  })
}
/**
 * 检测锁
 * @param webContents
 * @param usbIn  是否为插入u盘
 * @return {Promise.<void>}
 */
async function testUsb (webContents, usbIn = false) {
  try {
    let pathstr = path.join('data/zhlData.dll')
    let libm = ffi.Library(pathstr, {
      'GetProductIDList': ['string', []]
    })
    // console.log(await libm.GetProductIDList())
    let alllist = await libm.GetProductIDList()
    if (alllist !== '') {
      // let productlist = alllist.split('|')
      // for (let i in productlist) {
      //   let productNum = productlist[i].split(':')[0]
      //   let productVerList = productlist[i].split(':')[1].split(';')
      // }
      let first = db.read().get('sc_hadInstall.first').value()
      webContents.send('usbIn', { lockmsg: alllist, first: first, usbIn: usbIn })
      if (usbIn) {
        usbFlag = true
        const notification = new Notification({
          title: '软件锁',
          body: '启动器检测到软件锁'
        })
        notification.show()
      }
    }
  } catch (err) {
    console.error(err)
  }
}

export default usbffi
