import Vue from 'vue'
import Router from 'vue-router'

Vue.use(Router)

export default new Router({
  routes: [
    {
      path: '/',
      name: 'startup-page',
      component: require('@/components/StartUpPage').default,
      children: [
        {
          path: 'firstopen',
          component: require('@/components/StartUpPage/FirstOpen').default,
          name: 'first-open'
        },
        {
          path: 'softwarelist',
          component: require('@/components/StartUpPage/SoftwareList').default,
          name: 'software-list'
        },
        {
          path: 'softwaredetail/:pid',
          component: require('@/components/StartUpPage/SoftwareDetail').default,
          name: 'software-detail'
        },
        {
          path: 'softwarestartup',
          component: require('@/components/StartUpPage/SoftwareStartup').default,
          name: 'software-startup',
          children: [
            {
              path: ':productid',
              component: require('@/components/StartUpPage/SoftwareStartupDetail').default,
              name: 'software-startup-detail'
            }
          ]
        }
      ]
    },
    {
      path: '*',
      redirect: '/'
    }
  ]
})
